'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function parseFromPreds(preds) {
  return _immutable2.default.Map().withMutations(function (predsMap) {
    for (var pred in preds) {
      if (preds.hasOwnProperty(pred)) {
        var imTags = preds[pred].map(function (tag) {
          return _immutable2.default.fromJS(tag);
        });
        predsMap.set(pred, _immutable2.default.Set(imTags));
      }
    }
  });
}

var LinkedDataBox = function () {
  function LinkedDataBox(tags) {
    _classCallCheck(this, LinkedDataBox);

    if (typeof tags === 'string' || tags instanceof String) {
      var parsed = JSON.parse(tags);
      this.tags = parseFromPreds(parsed);
    } else if (tags instanceof LinkedDataBox) {
      this.tags = tags.tags;
    } else if (tags !== undefined) {
      this.tags = parseFromPreds(tags);
    } else {
      this.tags = _immutable2.default.Map();
    }
  }

  _createClass(LinkedDataBox, [{
    key: 'toJSON',
    value: function toJSON() {
      return this.tags.toObject();
    }
  }, {
    key: 'fromJSON',
    value: function fromJSON(parsed) {
      this.tags = parseFromPreds(parsed);
    }
  }, {
    key: 'iterateTags',
    value: function iterateTags(func) {
      var idx = 0;
      var iter = this.tags.entries();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.tags.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _step$value = _slicedToArray(_step.value, 2),
              pred = _step$value[0],
              tags = _step$value[1];

          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = tags[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var tag = _step2.value;

              var obj = tag;
              if (_immutable2.default.Map.isMap(obj)) {
                obj = tag.toObject();
              }
              func(pred, obj, idx);
              idx = idx + 1;
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: 'mapTags',
    value: function mapTags(func) {
      var arr = [];
      this.iterateTags(function (pred, tag, idx) {
        arr.push(func(pred, tag, idx));
      });
      return arr;
    }
  }, {
    key: 'addTag',
    value: function addTag(predicate, value) {
      var kv = {};
      kv[predicate] = _immutable2.default.Set([_immutable2.default.fromJS(value)]);
      var added = _immutable2.default.Map(kv);
      this.tags = this.tags.mergeWith(function (prev, next) {
        if (!prev) {
          return next;
        } else {
          return next.union(prev);
        }
      }, added);
    }
  }, {
    key: 'hasTag',
    value: function hasTag(predicate, value) {
      if (this.tags.has(predicate)) {
        return this.tags.get(predicate).has(_immutable2.default.fromJS(value));
      } else {
        return false;
      }
    }
  }, {
    key: 'getTagId',
    value: function getTagId(predicate, id) {
      if (!this.tags.has(predicate)) {
        return undefined;
      }
      var value = this.tags.get(predicate).find(function (x) {
        if (x.get('@id') === id) {
          return true;
        }
      });
      if (value) {
        return value.toJS();
      } else {
        return undefined;
      }
    }
  }, {
    key: 'hasTagId',
    value: function hasTagId(predicate, id) {
      var value = this.getTagId(predicate, id);
      if (value) {
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: 'deleteTag',
    value: function deleteTag(predicate, value) {
      this.tags = this.tags.update(predicate, function (v) {
        return v.remove(_immutable2.default.fromJS(value));
      });
    }
  }, {
    key: 'deleteTagId',
    value: function deleteTagId(predicate, id) {
      this.tags = this.tags.update(predicate, function (v) {
        var value = v.find(function (x) {
          if (x.get('@id') === id) {
            return true;
          }
        });
        return v.remove(_immutable2.default.fromJS(value));
      });
    }
  }]);

  return LinkedDataBox;
}();

exports.default = LinkedDataBox;